# Supports Organizer.rb
=begin
Copyright 2009, Matt
All Rights Reserved

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

License:   Free

Author:     	Matthieu NOBLET
Organization:   Matt
Name:      		Recall_lst_tool
Version:   		1.2
SU Version:   	6 and 7
Date:      		09/04/2009
Description:   	Recall last tool used
Usage:      	If you want to have a shortcut, please try with native Sketchup shortcuts...
History:
	1.200	09/04/2009
			Observer was not always activated before using tool. Thank you Simon Le Bon!
			
	1.100	17/02/2009
			Global variables replaced by Class variables
	
	1.000   17/02/2009
			First version
=end

require 'sketchup.rb'

class Matt_Observer < Sketchup::ToolsObserver
	@@Matt_Model_Toolid = nil
	@@Matt_Model_Toolid2 = nil
	def onActiveToolChanged (tools_object, toolname, toolid)
		@@Matt_Model_Toolid = @@Matt_Model_Toolid2 if @@Matt_Model_Toolid2
		@@Matt_Model_Toolid2 = toolid if not([21022,10508].index toolid)
	end
	def self.recall_last
		if @@Matt_Model_Toolid
			return Sketchup.send_action(@@Matt_Model_Toolid)
		else
			puts "No tool used before."
			return Sketchup.send_action("selectSelectionTool:")
		end
	end
end

Sketchup.active_model.tools.add_observer(Matt_Observer.new)

unless file_loaded?(__FILE__)
   file_loaded(__FILE__)
   $submenu ? (organizer = $submenu) : (organizer = UI.menu("Plugins"))
   organizer.add_item("Recall last tool"){ Matt_Observer.recall_last }
end
